#include <bits/stdc++.h>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    int a[n];
    for(int i = 0; i < n; i++) cin >> a[i];
    int pref[n];
    pref[0] = 0;
    for(int i = 1; i < n; i++) pref[i] = pref[i - 1] + (a[i - 1] > a[i]);
    int prv[n];
    prv[0] = -1;
    for(int i = 1; i < n; i++) {
        if(a[i - 1] > a[i]) prv[i] = i - 1;
        else prv[i] = prv[i - 1];
    }
    int q;
    cin >> q;
    while(q--) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        if(pref[r] - pref[l] == 0) cout << "DA\n";
        else if(pref[r] - pref[l] == 1) {
            int index = prv[r];
            if(index == l || index == r - 1 || a[index - 1] <= a[index + 1] || a[index] <= a[index + 2]) cout << "DA\n";
            else cout << "NE\n";
        } else cout << "NE\n";
    }
    return 0;
}